; 
    include \masm32\include\masm32rt.inc
    .586
    .xmm
	include \masm32\macros\timers.asm

; 
comment *Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros - lingo *
.code
option prologue:none  ; turn it off
option epilogue:none  ;
align  16             ;
bin2asciiL proc lpbuf:DWORD, nNumber:DWORD
mov 	eax, [esp+2*4]			; eax ->number
mov 	edx, 89705F41h 		; 1e-9 * 2^61 rounded
cmp eax,-1
mov	ecx, eax				;
je @f
add  eax, 1
@@:
mul 	edx 				; Divide by 1e9 by multiplying with reciprocal.
mov	[esp+2*4], edi			;
shr 	edx, 29 				; Leading decimal digit, 0...4
imul 	eax, edx, 1000000000 	; Leading digit * 1e9
mov	edi,  [esp+1*4]			; edi ->buffer
sub 	eax, ecx 			; Subtract (leading digit * 1e9) from argument.
lea	ecx,  [edx+30h]
mov 	edx, 0ABCC7712h 		; 2^28 / 1e8 * 2^30 rounded up
neg	eax
mul 	edx 				; Divide reduced
mov 	[edi], cl 				; Store leading digit
cmp 	ecx, 31h			; Any nonzero digit yet?
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
shr 	eax,  30 				; argument < 1e9 by 1e8,
lea 	eax,  [eax+4*edx+1]		; converting it into 4.28 fixed-point
mov 	edx, 0FFFFFFFh
and 	edx, eax ;  0FFFFFFFh 		; Fraction part

shr 	eax,  28 				; Next digit
add	ecx, eax
add 	eax,  30h 			; Convert digit to ASCII.
cmp 	ecx,  31h			; Any nonzero digit yet?
mov 	[edi], al 				; Store digit in memory
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
lea 	eax,  [edx*4+edx] 		; 5 * fraction, new digit EAX[31-27]
mov               edx,  7FFFFFFh  		; 5 * fraction, new fraction EDX[26-0]
and 	edx,  eax 			; Fraction part
shr 	eax,  27 				; Next digit
add	ecx,  eax
add 	eax,  30h 			; Convert digit to ASCII
mov 	[edi], al 				; Store digit in memory.
lea	eax,  [edx*4+edx+0C0000000h] ; 5 * fraction, new digit EAX[31-26]
cmp 	ecx,  31h 			; Any nonzero digit yet?
mov 	edx,  3FFFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and               edx,  eax			;
shr 	eax,  26 				; Next digit
or	ecx, eax

mov 	[edi], al 				; Store digit in memory.\
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+60000000h] ; 5 * fraction, new digit EAX[31-25]
mov 	edx,  1FFFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and 	edx,  eax			; Fraction part
shr 	eax,  25 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit in memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+30000000h] ; 5 * fraction, new digit EAX[31-24]
mov 	edx,  0FFFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr, No, keep old ptr.
and	edx,  eax			;
shr 	eax,  24 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit in memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+18000000h] ; 5 * fraction, new digit EAX[31-23]
mov 	edx,  7FFFFFh 		; Fraction part

sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and	edx,  eax			;
shr 	eax,  23 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit out to memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+0C000000h] ; 5 * fraction, new digit EAX[31-22]
mov 	edx,  3FFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and               edx,  eax			;
shr 	eax,  22 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit in memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+6000000h]  ; 5 * fraction, new digit EAX[31-21]
mov 	edx,  1FFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and 	edx,  eax			;
shr 	eax,  21 				; Next digit
mov 	[edi], al 				; Store digit in memory

or	ecx, eax
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+3000000h] ; 5 * fraction, new digit EAX[31-20]
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
shr 	eax,   20 			; Next digit
mov 	[edi],  ax 			; Store last digit and end marker in memory.
mov	edi,    [esp+2*4]		; Restore register as per calling convention
ret 	2*4 				; Pop two DWORD arguments and return
bin2asciiL	endp				; Total 88 instructions vs 101 from AMD
option prologue:prologuedef ; turn back on the defaults
option epilogue:epiloguedef ;



comment *Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros - AMD *
.code
option prologue:none  ; turn it off
option epilogue:none  ;
align  16             ;
bin2ascii proc lpbuf:DWORD, nNumber:DWORD
push 	edi 				; Save as per calling conventions.
push 	ebx 				; Save as per calling conventions.
mov 	edi,  [esp+2*4+1*4]		; sptr ->buffer
mov 	eax, [esp+2*4+2*4]		; x ->number
mov 	ecx, eax 			; Save original argument.
mov 	edx, 89705F41h 		; 1e-9 * 2^61 rounded
mul 	edx 				; Divide by 1e9 by multiplying with reciprocal.
add 	eax, eax 			; Round division result.
adc 	edx, 0 			; EDX[31-29] = argument / 1e9
shr 	edx, 29 			; Leading decimal digit, 0...4
mov 	eax, edx 			; Leading digit
mov 	ebx, edx 			; Initialize digit accumulator with leading digit.
imul 	eax, 1000000000 		; Leading digit * 1e9
sub 	ecx, eax 			; Subtract (leading digit * 1e9) from argument.
or 	dl,    '0' 			; Convert leading digit to ASCII.
mov 	[edi], dl 			; Store leading digit.
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
mov 	eax, ecx 			; Get reduced argument < 1e9.
mov 	edx, 0ABCC7712h 		; 2^28 / 1e8 * 2^30 rounded up
mul 	edx 				; Divide reduced
shr 	eax, 30 			; argument < 1e9 by 1e8,
lea 	edx, [eax+4*edx+1]	; converting it into 4.28 fixed-point
mov 	eax, edx 			; format such that 1.0 = 2^28.
shr 	eax, 28 			; Next digit
and 	edx, 0FFFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-27]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[26-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 27 			; Next digit
and 	edx, 7FFFFFFh 		; Fraction part
or	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-26]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[25-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 26 			; Next digit
and 	edx, 3FFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-25]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[24-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 25 			; Next digit
and 	edx, 1FFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-24]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[23-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr, No, keep old ptr.
shr 	eax, 24 			; Next digit
and 	edx, 0FFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-23]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[31-23]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 23 			; Next digit
and 	edx, 7FFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit out to memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-22]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[22-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 22 			; Next digit
and 	edx, 3FFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit
or 	eax, '0'			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-21]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[21-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 21 			; Next digit
and 	edx, 1FFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-20]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 20 			; Next digit
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], ax 			; Store last digit and end marker in memory.
pop 	ebx 				; Restore register as per calling convention.
pop 	edi 				; Restore register as per calling convention.
ret 	2*4 				; Pop two DWORD arguments and return.
bin2ascii endp        ;
option prologue:prologuedef ; turn back on the defaults
option epilogue:epiloguedef ;


;Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros
; algo from Paul Dixon		        ;
option prologue:none			    ; turn it off
option epilogue:none				;
align 16 
udwordl proc lpbuf:DWORD, nNumber:DWORD    ;unsigned DWORD to ASCII
	mov	eax,	[esp+2*4]		; eax->number
   	mov	edx,	0D1B71759h	; =2^45\10000    13 bit extra shift
	mov	[esp+2*4], edi		; save edi
	mov	edi,	eax			; save a copy of the number
	mov	ecx,	[esp+1*4]		; ecx-> sptr
 	mul	edx				; gives 6 high digits in edx
	mov 	[esp+1*4], esi		; save esi
	shr	edx,	13			; correct for multiplier offset used to give better accuracy
	mov	eax,	68DB9h		; =2^32\10000+1
	je	skiphighdigits		; if zero then dont need to process the top 6 digits
	imul	esi, edx, 10000		; get a copy of high digits ;scale up high digits
	sub	edi, 	esi			; subtract high digits from original. EDI now = lower 4 digits
	mul	edx				; get first 2 digits in edx
	mov	esi,	100			; load ready for later
	jnc	next1				; if zero, supress them by ignoring
	cmp	edx,	9			; 1 digit or 2?
	lea	ecx,	[ecx+8]		;
	ja	ZeroSupressed		; 2 digits, just continue with pairs of digits to the end
	add	edx, 	30h			;
	sub	ecx,	1			; update pointer by 1
	mov	[ecx-7],	edx			; but only write the 1 we need, supress the leading zero
	jne	ZS1  				; continue with pairs of digits to the end
align 16							;		
ZeroSupressed:						;
	mov	edx,	dword ptr chartab[edx+edx]	; look up 2 digits
	mov	[ecx-8], edx 				; write them to answer
ZS1:							;	
	mul	esi					; get next 2 digits
ZS1a:							;
	mov	edx,	dword ptr chartab[edx+edx]	; look up 2 digits
	mov	[ecx-6], edx				; write them to answer
ZS2:							;
	mul	esi					; get next 2 digits
ZS2a:							;
	mov	edx,	dword ptr chartab[edx+edx]	; look up 2 digits
	mov	[ecx-4], edx				; write them to answer
ZS3:							;
	mov	eax,	28F5C29h			; 2^32\100 +1
	mul	edi					; edi= lower 4 digits
ZS3a:							;	
	mov	edx,	dword ptr chartab[edx+edx]	; look up 2 digits
	mov	[ecx-2],	edx				; write to answer
ZS4:							;
	mul	esi					; get final 2 digits
ZS4a:							;
	mov	esi,	[esp+1*4]			; restore esi
	lea	eax,	[ecx+2]			;
	mov	edi,	[esp+2*4]			; restore edi
	movzx	eax,	word ptr chartab[edx+edx]	; look them up
	mov	[ecx],	eax				; write to answer and zero terminate string
	ret	2*4					; all done
align 16							;
next1:							;
	mul	esi  					; get next 2 digits
	jnc	next2                  			; if zero, supress them by ignoring
	cmp	edx,	9                  			; 1 digit or 2?
	lea	ecx,	[ecx+6]			;
	ja	ZS1a                   			; 2 digits, just continue with pairs of digits to the end
	add	edx,	30h				;		
	sub	ecx,	1		   		; update pointer by 1
	mov	[ecx-5], edx 				; but only write the 1 we need, supress the leading zero
	jnz	ZS2					; continue with pairs of digits to the end
align 16							;	
next2:							;
	mul	esi					; get next 2 digits
	jnc	next3					; if zero, supress them by ignoring
	cmp	edx,	9				; 1 digit or 2?
	lea	ecx,	[ecx+4]			;
	ja	ZS2a					; 2 digits, just continue with pairs of digits to the end
	add	edx,	30h				;
	sub	ecx,	1				; update pointer by 1
	mov	[ecx-3],	edx				; but only write the 1 we need, supress the leading zero
	jnz	ZS3					; continue with pairs of digits to the end
align 16							;	
next3:							;
skiphighdigits:						;
	mov	eax,	28F5C29h         		; 2^32\100 +1
	mul	edi					; edi = lower 4 digits
	mov	esi,	100				;
	jnc	next4					; if zero, supress them by ignoring
	cmp	edx,	9				; 1 digit or 2?
	lea	ecx,	[ecx+2]			;
	ja	ZS3a					; 2 digits, just continue with pairs of digits to the end
	add	edx,	30h				;
	sub	ecx,	1				; update pointer by 1
	mov	[ecx-1],	edx				; but only write the 1 we need, supress the leading zero
	jnz	ZS4					; continue with pairs of digits to the end
align 16							;
next4:							;
	mul	esi					; this is the last pair so don;t supress a single zero
	cmp	edx,	9				; 1 digit or 2?
	ja	ZS4a					; 2 digits, just continue with pairs of digits to the end
	mov	esi,	[esp+1*4]			; restore esi
	add	edx,	30h				;
	mov	edi,	[esp+2*4]			; restore edi
	lea	eax,	[ecx+1]			;
	mov	[ecx], 	edx				; zero terminate string
	ret	2*4					; all done
udwordl endp    


align 16 
udword proc lpbuf:DWORD, nNumber:DWORD    ;unsigned DWORD to ASCII
    push edi                   ;save registers that need to be saved
    push esi

    mov  esi, [esp+12]      ; sptr
    mov  eax, [esp+16]      ; x

    mov edi,eax                ;save a copy of the number

    mov edx, 0D1B71759h        ;=2^45\10000    13 bit extra shift
    mul edx                    ;gives 6 high digits in edx

    mov eax,68DB9h            ;=2^32\10000+1

    shr edx,13                 ;correct for multiplier offset used to give better accuracy
    jz short skiphighdigits          ;if zero then don;t need to process the top 6 digits


    mov ecx,edx                ;get a copy of high digits
    imul ecx,10000             ;scale up high digits
    sub edi,ecx                ;subtract high digits from original. EDI now = lower 4 digits


    mul edx                    ;get first 2 digits in edx
    mov ecx,100                ;load ready for later

    jnc short next1                  ;if zero, supress them by ignoring
    cmp edx,9                  ;1 digit or 2?
    ja  short ZeroSupressed          ;2 digits, just continue with pairs of digits to the end

    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc esi                    ;update pointer by 1
    jmp short ZS1               ;continue with pairs of digits to the end

next1:
    mul ecx                    ;get next 2 digits
    jnc short next2                  ;if zero, supress them by ignoring
    cmp edx,9                  ;1 digit or 2?
    ja  short ZS1a                   ;2 digits, just continue with pairs of digits to the end

    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc esi                    ;update pointer by 1
    jmp short ZS2               ;continue with pairs of digits to the end

next2:
    mul ecx                    ;get next 2 digits
    jnc short next3                  ;if zero, supress them by ignoring
    cmp edx,9                  ;1 digit or 2?
    ja  short ZS2a                   ;2 digits, just continue with pairs of digits to the end

    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc esi                    ;update pointer by 1
    jmp short ZS3               ;continue with pairs of digits to the end

next3:

skiphighdigits:
    mov eax,edi                ;get lower 4 ditigs

    mov ecx,100

    mov edx,28F5C29h          ;2^32\100 +1
    mul edx
    jnc short next4                  ;if zero, supress them by ignoring
    cmp edx,9                  ;1 digit or 2?
    ja  short ZS3a                   ;2 digits, just continue with pairs of digits to the end

    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc esi                    ;update pointer by 1
    jmp short  ZS4               ;continue with pairs of digits to the end


next4:
    mul ecx                    ;this is the last pair so don;t supress a single zero
    cmp edx,9                  ;1 digit or 2?
    ja  short ZS4a                   ;2 digits, just continue with pairs of digits to the end

    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dh               ;but only write the 1 we need, supress the leading zero
    mov byte ptr [esi+1],0     ;zero terminate string


    jmp short  xit               ;all done


ZeroSupressed:
    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dx
    add esi,2                  ;write them to answer

ZS1:
    mul ecx                    ;get next 2 digits
ZS1a:
    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dx               ;write them to answer
    add esi,2

ZS2:
    mul ecx                    ;get next 2 digits
ZS2a:
    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dx               ;write them to answer
    add esi,2

ZS3:
    mov eax,edi                ;get lower 4 digits
    mov edx,28F5C29h         ;2^32\100 +1
    mul edx                    ;edx= top pair
ZS3a:
    mov edx,dword ptr chartab[edx*2]     ;look up 2 digits
    mov [esi],dx               ;write to answer
    add esi,2                  ;update pointer

ZS4:
    mul ecx                    ;get final 2 digits
ZS4a:
    mov edx,dword ptr chartab[edx*2]     ;look them up
    mov [esi],dx               ;write to answer

    mov byte ptr [esi+2],0     ;zero terminate string


xit:
    pop esi                    ;restore used registers
    pop edi 
    ret 8
udword endp    
option prologue:prologuedef ; turn back on the defaults
option epilogue:epiloguedef ;             


;Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros
; Idea by Paul Dixon		        ;
option prologue:none			    ; turn it off
option epilogue:none				;
align 16					                ; 
bi2asciiL	proc 	lpbuf:DWORD, nNumber:DWORD
	mov	eax,	[esp+2*4]
	mov	edx,	2814749767
	mov	[esp+2*4],	edi
	cmp	eax, 	-1
	mov	edi, 	[esp+1*4]
	mov	ecx,	eax	
	mov	[esp+1*4], ebx
	je	@f
	add 	eax, 	1 
@@:		
	mov	dword	ptr [edi], 30303030h
	mul	edx
	mov	byte	ptr [edi+8], 30h
	shr	edx,	16
	mov	ebx,	10
	mov	eax,	edx					
	imul	eax, 	100000
	mov	dword ptr [edi+4], 30303030h	
	sub	edi,	5	
	sub	ecx,	eax						
	test	edx,	edx						
	mov	eax,	429497
	jz 	ET01
	mul	edx
	lea	edi,	[edi+5]
	jc	ET02
	mul	ebx							
	lea	edi,	[edi-1]					
	jc	ET03							
	mul	ebx
	lea	edi,	[edi-1]	
	jc	ET04
	mul	ebx
	lea	edi,	[edi-1]	
	jc	ET05
	mul	ebx
	lea	edi,	[edi-1]	
	jc	ET06
	mov	eax,	429497
	sub	edi,	1	
ET01:
	mul	ecx
	jc	ET07
	mul	ebx
	lea	edi,	[edi-1]	
	jc	ET08
	mul	ebx
	lea	edi,	[edi-1]	
	jc	ET09
	mul	ebx
	lea	edi,	[edi-1]	
	jc	ET10
	mov	ebx,	[esp+1*4]
	add	ecx,	30h
	mov	word ptr [edi+9-1], cx
	mov	edi,	[esp+2*4]
	ret	2*4
align 16
ET02:
	add	byte ptr [edi], dl
	mul	ebx
ET03:
	add	byte ptr [edi+1], dl
	mul	ebx								
ET04:
	add	byte ptr [edi+2], dl
	mul	ebx
ET05:
	add	byte ptr [edi+3], dl
	mul	ebx
ET06:
	mov	eax, 429497
	add	byte ptr [edi+4], dl
	mul	ecx	
ET07:
	add	byte ptr [edi+5], dl
	mul	ebx				
ET08:
	add	byte ptr [edi+6], dl
	mul	ebx
ET09:
	add	byte ptr [edi+7], dl
	mul	ebx
ET10:
	add	byte ptr [edi+8], dl
	mul	ebx
ET11:
	mov	ebx, 	[esp+1*4]
	add	edx, 	30h
	mov	word ptr [edi+9], dx
	mov	edi, 	[esp+2*4]
	ret 	2*4 			; Pop two DWORD arguments and return
bi2asciiL	endp				; Total 88 instructions vs 101 from AMD
option prologue:prologuedef         		;  turn back on the defaults
option epilogue:epiloguedef          		;                      


ALIGN 16
;
; syntax :
; mov eax,value
; mov edi,StringPointer
; call uDw2Ascii
;
uDw2Ascii PROC
		push ebx									;; empiler ebx
		push edi									;; empiler edi

		mov ecx,eax								;; copier eax dans ecx
inc eax
jz SpecialCase
; on va diviser eax par 100000 de manire optimise
;		mov edx,2814749768							;; placer 2814749768 (remplacement de 2814749767 et eax+1) dans edx
mov edx,2814749767
		sub edi,5									;; enlever 5 caractres  edi
		mul edx									;; multiplier eax par 2814749768
		shr edx,16								;; dcaler edx de 16 bits  droite
		mov eax,100000								;; placer 100000 dans eax
		mov ebx,edx								;; copier edx dans ebx
		mul edx									;; multiplier edx par 100000
		sub ecx,eax								;; soustraire le rsultat en eax  ecx
		test ebx,ebx								;; fixer les flags de ebx
		mov edx,ebx								;; replacer ebx dans edx
		mov ebx,10								;; placer 10 (notre multiplicateur dcimale) dans ebx
		jz Label01								;; si c'est gal  0, aller Label01
; sinon, on traite la partie suprieure du nombre
		mov eax,429497								;; on remplace eax par 429497
		add edi,5									;; ici, il y a plus de 5 caractres alors on rajoute les 5 qu'on avait enlev
		mul edx									;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label02								;; s'il existe un dpassement, aller Label02
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label03								;; s'il existe un dpassement, aller Label03
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label04								;; s'il existe un dpassement, aller Label04
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label05								;; s'il existe un dpassement, aller Label05
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label06								;; s'il existe un dpassement, aller Label06
		dec edi									;; dcrmenter l'adresse
; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label07								;; s'il existe un dpassement, aller Label07
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label08								;; s'il existe un dpassement, aller Label08
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label09								;; s'il existe un dpassement, aller Label09
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label10								;; s'il existe un dpassement, aller Label10
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jmp Label11								;; aller Label11
; ici, on va placer XXXXXXXXXX et le zro final
Label02:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label03:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+1],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label04:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+2],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label05:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+3],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label06:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+4],dl						;; placer l'octet en dl  l'adresse en edi
		mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
Label07:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+5],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label08:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+6],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label09:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+7],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label10:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+8],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label11:	add dx,30h								;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [edi+9],dx						;; placer l'octet en dl et le 0 final en dh  l'adresse en edi

		pop edi									;; dsempiler edi
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)

SpecialCase:
mov DWORD PTR [edi],"4924"
mov DWORD PTR [edi+4],"2769"
mov WORD PTR [edi+8],"59"
mov BYTE PTR [edi+10],0

		pop edi									;; dsempiler edi
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)
uDw2Ascii ENDP






.data
align 16
szBuffer   	db	30 Dup(0)

;The character look up table. Make sure it's aligned suitably
align 16
chartab    dw "00","10","20","30","40","50","60","70","80","90"
    dw "01","11","21","31","41","51","61","71","81","91"
    dw "02","12","22","32","42","52","62","72","82","92"
    dw "03","13","23","33","43","53","63","73","83","93"
    dw "04","14","24","34","44","54","64","74","84","94"
    dw "05","15","25","35","45","55","65","75","85","95"
    dw "06","16","26","36","46","56","66","76","86","96"
    dw "07","17","27","37","47","57","67","77","87","97"
    dw "08","18","28","38","48","58","68","78","88","98"
    dw "09","19","29","39","49","59","69","79","89","99"   


.code
; 
start:
; 
    ;function tests

    invoke	bin2ascii, addr szBuffer, 123456789
    print ADDR szBuffer,13,10
    invoke	bin2asciiL, addr szBuffer, 123456789
    print ADDR szBuffer,13,10
    invoke	bi2asciiL, addr szBuffer, 123456789
    print ADDR szBuffer,13,10    
    mov eax, 123456789
    mov edi, OFFSET szBuffer
    call uDw2Ascii
    print ADDR szBuffer,13,10
    invoke	udword, addr szBuffer, 123456789
    print ADDR szBuffer,13,10
    invoke	udwordl, addr szBuffer, 123456789
    print ADDR szBuffer,13,10    




    invoke Sleep, 4000

    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	bin2ascii, addr szBuffer, 0FFFFFFFEh
    counter_end
    print ustr$(eax)," cycles, bin2ascii-AMD",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	bin2asciiL, addr szBuffer, 0FFFFFFFEh
    counter_end
    print ustr$(eax)," cycles, bin2ascii-lingo",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	bi2asciiL, addr szBuffer, 0FFFFFFFEh
    counter_end
    print ustr$(eax)," cycles, bi2ascii-lingo 2",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
    mov eax, 0FFFFFFFEh
    mov edi, OFFSET szBuffer
    call uDw2Ascii
    counter_end
    print ustr$(eax)," cycles, uDw2Ascii - NightWare",13,10


    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	udword, addr szBuffer, 0FFFFFFFEh
    counter_end
    print ustr$(eax)," cycles, udword-p.dixon",13,10

   counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	udwordl, addr szBuffer, 0FFFFFFFEh
    counter_end
    print ustr$(eax)," cycles, udwordl-lingo 3",13,10

    inkey "Press any key to exit..."
    exit
; 
end start



